package ru.landgrafhomyak.db.sql_skeleton_0.api.module

import ru.landgrafhomyak.db.sql_skeleton_0.api.table.Table
import ru.landgrafhomyak.db.sql_skeleton_0.api.table.TableConstructor
import ru.landgrafhomyak.db.sql_skeleton_0.api.table.TableUpgrade


public interface UpgradeModuleScope<nmUE : Any, omUE : Any, RUNTIME_KEY : Any> : CreateModuleScope<nmUE, RUNTIME_KEY> {
	public fun <tUE : Any> keepTable(table: Table<tUE, omUE, RUNTIME_KEY>): Table<tUE, nmUE, RUNTIME_KEY>

	public fun <tUE : Any> keepAndRenameTable(table: Table<tUE, omUE, RUNTIME_KEY>, newName: String): Table<tUE, nmUE, RUNTIME_KEY>
	public fun <tUE : Any> keepAndRenameTable(table: Table<tUE, omUE, RUNTIME_KEY>, newNamespace: Namespace<nmUE, RUNTIME_KEY>): Table<tUE, nmUE, RUNTIME_KEY>
	public fun <tUE : Any> keepAndRenameTable(table: Table<tUE, omUE, RUNTIME_KEY>, newNamespace: Namespace<nmUE, RUNTIME_KEY>, newName: String): Table<tUE, nmUE, RUNTIME_KEY>

	public fun <ntUE : Any, otUE : Any> upgradeTable(oldTable: Table<otUE, omUE, RUNTIME_KEY>, upgrade: TableUpgrade<ntUE, otUE, RUNTIME_KEY>): Table<ntUE, nmUE, RUNTIME_KEY>
	public fun <ntUE : Any, otUE : Any> upgradeAndRenameTable(
		table: Table<otUE, omUE, RUNTIME_KEY>,
		newName: String,
		upgrade: TableUpgrade<ntUE, otUE, RUNTIME_KEY>
	): Table<ntUE, nmUE, RUNTIME_KEY>

	public fun <ntUE : Any, otUE : Any> upgradeAndRenameTable(
		table: Table<otUE, omUE, RUNTIME_KEY>,
		newNamespace: Namespace<nmUE, RUNTIME_KEY>,
		upgrade: TableUpgrade<ntUE, otUE, RUNTIME_KEY>
	): Table<ntUE, nmUE, RUNTIME_KEY>

	public fun <ntUE : Any, otUE : Any> upgradeAndRenameTable(
		table: Table<otUE, omUE, RUNTIME_KEY>,
		newNamespace: Namespace<nmUE, RUNTIME_KEY>,
		upgrade: TableUpgrade<ntUE, otUE, RUNTIME_KEY>,
		newName: String
	): Table<ntUE, nmUE, RUNTIME_KEY>

	public fun deleteTable(table: Table<*, omUE, RUNTIME_KEY>)

	public fun <tUE : Any> deleteTableAfterModuleUpgrade(table: Table<tUE, omUE, RUNTIME_KEY>): Table<tUE, nmUE, RUNTIME_KEY>

	public fun exportTable(table: Table<*, omUE, RUNTIME_KEY>)

	public fun <tUE : Any> importTable(
		namespace: Namespace<nmUE, RUNTIME_KEY> = this.rootNs, name: String,
		table: Table<tUE, *, RUNTIME_KEY>
	): Table<tUE, nmUE, RUNTIME_KEY>

	public fun <ntUE : Any, otUE : Any> importAndUpgradeTable(
		namespace: Namespace<nmUE, RUNTIME_KEY> = this.rootNs, name: String,
		table: Table<otUE, *, RUNTIME_KEY>,
		upgrade: TableUpgrade<ntUE, otUE, RUNTIME_KEY>
	): Table<ntUE, nmUE, RUNTIME_KEY>

	public fun <smUE : Any> keepModule(module: Module<smUE, RUNTIME_KEY>): Module<smUE, RUNTIME_KEY>
	public fun <smUE : Any> keepAndMoveModule(oldModule: Module<smUE, RUNTIME_KEY>, newNs: Namespace<nmUE, RUNTIME_KEY>): Module<smUE, RUNTIME_KEY>

	public fun <smUE : Any> upgradeModule(oldModule: Module<*, RUNTIME_KEY>, template: ModuleTemplate<smUE>): Module<smUE, RUNTIME_KEY>
	public fun <smUE : Any> upgradeAndMoveModule(oldModule: Module<*, RUNTIME_KEY>, newNs: Namespace<nmUE, RUNTIME_KEY>, template: ModuleTemplate<smUE>): Module<smUE, RUNTIME_KEY>

	public fun removeModule(oldModule: Module<*, RUNTIME_KEY>)
	public fun <smUE : Any> removeModuleAfterUpgrade(oldModule: Module<smUE, RUNTIME_KEY>): Module<smUE, RUNTIME_KEY>
}